# sahi
# stroyka.in
# Дата: 15.06.2012
# selection_edge.rb
# :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< 

require "sketchup.rb"

class MySelectionEdge < Sketchup::SelectionObserver
	def initialize()
		@select_edge = false
		@select_face = false
		#@edge_smooth = false
	end
				
	def onSelectionBulkChange(selection)
		Sketchup.active_model.selection.remove_observer self
		get_selection_edge(selection) if(@select_edge)
		# get_selection_edge_smooth(selection) if(@edge_smooth)
		get_selection_face(selection) if(@select_face)
		Sketchup.active_model.selection.add_observer self
	end
		
	def start_selection_edge
		if(@select_edge) then 
			@select_edge = false
			Sketchup.active_model.selection.remove_observer self
		else
			@select_edge = true
			@select_face = false
			#  @edge_smooth = false
			get_selection_edge(Sketchup.active_model.selection)
			Sketchup.active_model.selection.add_observer self
		end
	end 
		
	# def start_selection_edge_smooth
	#     if(@edge_smooth) then 
	#       @edge_smooth = false
	#     	Sketchup.active_model.selection.remove_observer self
	#     else
	#       @edge_smooth = true
	#       @select_edge = false
	#       @select_face = false
	#       get_selection_edge_smooth(Sketchup.active_model.selection)
	#       Sketchup.active_model.selection.add_observer self
	#     end
	#   end 
		
	def start_selection_face
		if(@select_face) then 
			@select_face = false
			Sketchup.active_model.selection.remove_observer self
		else
			@select_face = true
			@select_edge = false
			#  @edge_smooth = false
			get_selection_face(Sketchup.active_model.selection)
			Sketchup.active_model.selection.add_observer self
		end
	end 
		
	def get_selection_edge(sel)
		# sel.each{|item| sel.remove(item) if item.class == Sketchup::Face }
		edges=sel.grep(Sketchup::Edge);sel.clear;sel.add edges
	end
				
	#  def get_selection_edge_smooth(sel)
	#        sel.each{|item| sel.remove(item) if item.class == Sketchup::Face || item.class == Sketchup::Edge && item.soft?}
	#       end
				
	def get_selection_face(sel)
		# sel.each{|item| sel.remove(item) unless item.class == Sketchup::Face}
		faces=sel.grep(Sketchup::Face);sel.clear;sel.add faces
	end
		
	def edge_selection
		if(@select_edge) then
			return MF_CHECKED
		else
			return MF_UNCHECKED			
		end
	end
		
	#   def edge_smooth
	#		if(@edge_smooth) then
	#			return MF_CHECKED
	#		else
	#		return MF_UNCHECKED			
	#		end
	#	end
		
	def face_selection
		if(@select_face) then
			return MF_CHECKED
		else
			return MF_UNCHECKED			
		end
	end
		
	end
	#----------------------------------------------
	if( not file_loaded?("selection_edge.rb") )
		select_edge = MySelectionEdge.new
		mydir = File.dirname(__FILE__)
		
		cmd = UI::Command.new("Select Edges") { select_edge.start_selection_edge }
		cmd.tooltip = "Select Edges" 
		cmd.status_bar_text = "Select Edges"
		cmd.large_icon = mydir + "/images/edge.png"
		cmd.small_icon = mydir + "/images/edge.png"
		cmd.set_validation_proc { select_edge.edge_selection }
		
		cmd1 = UI::Command.new("Select Face") { select_edge.start_selection_face }
		cmd1.tooltip = "Select Face"
		cmd1.status_bar_text = "Select Face"
		cmd1.large_icon = mydir + "/images/face.png"
		cmd1.small_icon = mydir + "/images/face.png"
		cmd1.set_validation_proc { select_edge.face_selection }
		
	#  cmd2 = UI::Command.new("Выделяем линии") { select_edge.start_selection_edge_smooth }
	#  cmd2.tooltip = "Выделение Граней" 
	#  cmd2.status_bar_text = "Выделение Граней"
	#  cmd2.large_icon = mydir + "/images/edge.png"
	#  cmd2.small_icon = mydir + "/images/edge.png"
	#  cmd2.set_validation_proc { select_edge.edge_smooth }
	
		tb = UI::Toolbar.new("Select >>>")
		tb.add_item(cmd)
		tb.add_item(cmd1)
		# tb.add_item(cmd2)
		tb.show
		
		# main_menu = UI.menu("Plugins").add_submenu("Выделяем >>>"){}
		# auto_edge = main_menu.add_item("Выделяем линии"){ select_edge.start_selection_edge}
		# auto_face = main_menu.add_item("Выделяем лица"){ select_edge.start_selection_face}
		# main_menu.set_validation_proc(auto_edge){select_edge.edge_selection}
		# main_menu.set_validation_proc(auto_face){select_edge.face_selection}
		file_loaded("selection_edge.rb")
	end
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=#

